# Intel compiler and/or TBB/MKL 
#
# EXPLANATIONS [RB]:
# In practise, the call to "compilervars.sh" or ("mklvars.sh", etc) sets PATH, LD_LIBRARY_PATH.
# If we want these variables to be set system-wide, it should be run in .profile
#  
# BUT
#  1. the gnome display manager unset LD_LIBRARY_PATH
#
#  2. if the login shell is "dash", the script cannot be called 
#     (we cannot add an extra argument to a sourced script with dash). 
# THEN
# => we call the scripts in both places (.bashrc & .profile)
# => the env is cleaned in "loop.sh", removing duplicates if the .profile was actually read by bash
#
# SPECIAL CASE: "at" job
# => the environment is OK and kept, but "LD_LIBRARY_PATH" is set to nothing by "at"
# => the .profile is then rerun manually in our scripts (with bash)
#    should we run also .bashrc as LD_LIBRARY_PATH should be set here on systems with gnome? 
# => duplicates are finally removed by loop.sh

if [ -n "$BASH_VERSION" ]; then
    if [ -d /opt/intel ] ; then
        # . /opt/intel/mkl/bin/mklvars.sh intel64
        # . /opt/intel/tbb/bin/tbbvars.sh intel64
        . /opt/intel/oneapi/mkl/latest/env/vars.sh
        . /opt/intel/oneapi/tbb/latest/env/vars.sh
    fi
fi
